//==== Constructeur de ImageSujet
function ImageSujet(IDCanvas){
    // Proprits (attributs) de la classe (et donc des objets crs  partir de cette classe)
    this.nomImage=0;
    this.IDCanvas=IDCanvas;
  
    this.canvas=0;
    this.context=0;
    this.image=0;
    this.data=0;
    this.largeur=0;
    this.hauteur=0;
    
    // Association fonctions <-> mthodes de la classe
    this.chargeEtAffiche=ImageSujet_chargeEtAffiche;
    this.accederDonnees=ImageSujet_accederDonnees;
    this.creer=ImageSujet_creer;
    this.affiche=ImageSujet_affiche;
    this.debugData=ImageSujet_debugData;
    this.getImage=ImageSujet_getImage;
    this.getLargeur=ImageSujet_getLargeur;
    this.getHauteur=ImageSujet_getHauteur;
    this.getValeur=ImageSujet_getValeur;
    this.getValeurR=ImageSujet_getValeurR;
    this.getValeurV=ImageSujet_getValeurV;
    this.getValeurB=ImageSujet_getValeurB;
    this.getValeurA=ImageSujet_getValeurA;
    this.setValeur=ImageSujet_setValeur;
    this.setValeurR=ImageSujet_setValeurR;
    this.setValeurV=ImageSujet_setValeurV;
    this.setValeurB=ImageSujet_setValeurB;
    this.setValeurA=ImageSujet_setValeurA;
}

//==== Fonctions (mthodes) de ImageSujet
function ImageSujet_chargeEtAffiche(nomImage){
    var monCanvas = document.getElementById(this.IDCanvas);
    var monContexte = monCanvas.getContext('2d');

    this.nomImage=nomImage;
    this.canvas=monCanvas;
    this.context=monContexte;

    var monImage = new Image();
    this.image=monImage;

    // On charge l'image mais  cause de la mthode, on ne peut pas sauver les paramtres de l'image
    // dans les variables de l'objet ImageSujet
    monImage.onload = function() {
        monCanvas.width = monImage.width;
        monCanvas.height = monImage.height;
        monContexte.drawImage(monImage,0,0,monImage.width,monImage.height);
    }
    monImage.src = this.nomImage;
}

function ImageSujet_accederDonnees(){
    this.canvas = document.getElementById(this.IDCanvas);
    this.context = this.canvas.getContext('2d');
    this.largeur=this.getLargeur();
    this.hauteur=this.getHauteur();
    this.data=this.context.getImageData(0,0,this.largeur,this.hauteur);
    return this.data;
}

function ImageSujet_creer(largeur, hauteur){
    this.canvas=document.createElement("canvas");
    this.context=this.canvas.getContext("2d");
    this.canvas.width=largeur;
    this.canvas.height=hauteur;
    this.largeur=largeur;
    this.hauteur=hauteur;
    this.data = this.context.createImageData(largeur, hauteur);
}


function ImageSujet_affiche(){
    var tmpCanvas = document.getElementById(this.IDCanvas);
    
    tmpCanvas.width=this.largeur;
    tmpCanvas.height=this.hauteur;
    
    var tmpContext=tmpCanvas.getContext("2d");
    tmpContext.putImageData(this.data, 0, 0);
}

function ImageSujet_getImage(){
    return this.image;
}

function ImageSujet_debugData(prefixe){
    console.log(prefixe+" this.data.data["+this.data.data[0]+","+this.data.data[1]+","+this.data.data[2]+"...");
}

function ImageSujet_getLargeur(){
    return this.image.width;
}

function ImageSujet_getHauteur(){
    return this.image.height;
}

function ImageSujet_getValeur(x,y,composante){
    //return(this.data.data[ (y * this.image.width + x) * 4 + composante ]);
    //return(this.data.data[ (y * 480 + x) * 4 + composante ]);
    return(this.data.data[ (y * this.largeur + x) * 4 + composante ]);
}

function ImageSujet_getValeurR(x,y){
    return(this.getValeur(x,y,0));
}
function ImageSujet_getValeurV(x,y){
    return(this.getValeur(x,y,1));
}
function ImageSujet_getValeurB(x,y){
    return(this.getValeur(x,y,2));
}
function ImageSujet_getValeurA(x,y){
    return(this.getValeur(x,y,3));
}

function ImageSujet_setValeur(x,y,v,composante){
    this.data.data[ (y * this.largeur + x) * 4 + composante ] = v;
}
function ImageSujet_setValeurR(x,y,v){
    this.setValeur(x,y,v,0);
}
function ImageSujet_setValeurV(x,y,v){
    this.setValeur(x,y,v,1);
}
function ImageSujet_setValeurB(x,y,v){
    this.setValeur(x,y,v,2);
}
function ImageSujet_setValeurA(x,y,v){
    this.setValeur(x,y,v,3);
}

